## Public API Reference

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# csPen Class Reference

A pen specialized for CS. More...

`#include <cstool/pen.h>`

Inheritance diagram for csPen:

[legend]
List of all members.

## Public Member Functions

virtual void | ClearTransform ()
| Clears the current transform, resets to identity.
virtual void | DrawArc (uint x1, uint y1, uint x2, uint y2, float start_angle=0, float end_angle=6.2831853, bool swap_colors=false, bool fill=false)
| Draws an elliptical arc from start angle to end angle.
virtual void | DrawLine (uint x1, uint y1, uint x2, uint y2)
| Draws a single line.
virtual void | DrawMiteredRect (uint x1, uint y1, uint x2, uint y2, float miter, bool swap_colors=false, bool fill=false)
| Draws a mitered rectangle.
virtual void | DrawPoint (uint x1, uint y2)
| Draws a single point.
virtual void | DrawRect (uint x1, uint y1, uint x2, uint y2, bool swap_colors=false, bool fill=false)
| Draws a rectangle.
virtual void | DrawRoundedRect (uint x1, uint y1, uint x2, uint y2, float roundness, bool swap_colors=false, bool fill=false)
| Draws a rounded rectangle.
virtual void | DrawTriangle (uint x1, uint y1, uint x2, uint y2, uint x3, uint y3, bool fill=false)
| Draws a triangle around the given vertices.
virtual void | PopTransform ()
| Pops the transform stack.
virtual void | PushTransform ()
| Pushes the current transform onto the stack.
virtual void | Rotate (const float &a)
| Rotates by the given matrix.
virtual void | SetColor (const csColor4 &color)
| Sets the current color.
virtual void | SetColor (float r, float g, float b, float a)
| Sets the current color.
virtual void | SetOrigin (const csVector3 &o)
| Sets the origin of the coordinate system.
virtual void | SwapColors ()
| Swaps the current color and the alternate color.
virtual void | Translate (const csVector3 &t)
| Translates by the given vector.
virtual void | Write (iFont *font, uint x1, uint y1, char *text)
| Writes text in the given font at the given location.
virtual void | WriteBoxed (iFont *font, uint x1, uint y1, uint x2, uint y2, uint h_align, uint v_align, char *text)
| Writes text in the given font, in the given box.

## Protected Member Functions

void | AddVertex (float x, float y)
| Adds a vertex.
void | DrawMesh (csRenderMeshType mesh_type)
| Worker, draws the mesh.
void | SetupMesh ()
| Worker, sets up the mesh with the vertices, color, and other information.
void | Start ()
| Initializes our working objects.

## Detailed Description

A pen specialized for CS.

Definition at line 159 of file pen.h.

## Member Function Documentation

void csPen::AddVertex | ( | float | x,
|  | float | y
| ) | `[protected]`

| Adds a vertex.

virtual void csPen::ClearTransform | ( |  | ) | `[virtual]`

| Clears the current transform, resets to identity. Implements iPen.

virtual void csPen::DrawArc | ( | uint | x1,
|  | uint | y1,
|  | uint | x2,
|  | uint | y2,
|  | float | start_angle = `0`,
|  | float | end_angle = `6.2831853`,
|  | bool | swap_colors = `false`,
|  | bool | fill = `false`
| ) | `[virtual]`

| Draws an elliptical arc from start angle to end angle. Angle must be specified in radians. The arc will be made to fit in the given box. If you want a circular arc, make sure the box is a square. If you want a full circle or ellipse, specify 0 as the start angle and 2*PI as the end angle. Implements iPen.

virtual void csPen::DrawLine | ( | uint | x1,
|  | uint | y1,
|  | uint | x2,
|  | uint | y2
| ) | `[virtual]`

| Draws a single line. Implements iPen.

void csPen::DrawMesh | ( | csRenderMeshType | mesh_type | ) | `[protected]`

| Worker, draws the mesh.

virtual void csPen::DrawMiteredRect | ( | uint | x1,
|  | uint | y1,
|  | uint | x2,
|  | uint | y2,
|  | float | miter,
|  | bool | swap_colors = `false`,
|  | bool | fill = `false`
| ) | `[virtual]`

| Draws a mitered rectangle. The miter value should be between 0.0 and 1.0, and determines how much of the corner is mitered off and beveled. Implements iPen.

virtual void csPen::DrawPoint | ( | uint | x1,
|  | uint | y2
| ) | `[virtual]`

| Draws a single point. Implements iPen.

virtual void csPen::DrawRect | ( | uint | x1,
|  | uint | y1,
|  | uint | x2,
|  | uint | y2,
|  | bool | swap_colors = `false`,
|  | bool | fill = `false`
| ) | `[virtual]`

| Draws a rectangle. Implements iPen.

virtual void csPen::DrawRoundedRect | ( | uint | x1,
|  | uint | y1,
|  | uint | x2,
|  | uint | y2,
|  | float | roundness,
|  | bool | swap_colors = `false`,
|  | bool | fill = `false`
| ) | `[virtual]`

| Draws a rounded rectangle. The roundness value should be between 0.0 and 1.0, and determines how much of the corner is rounded off. Implements iPen.

virtual void csPen::DrawTriangle | ( | uint | x1,
|  | uint | y1,
|  | uint | x2,
|  | uint | y2,
|  | uint | x3,
|  | uint | y3,
|  | bool | fill = `false`
| ) | `[virtual]`

| Draws a triangle around the given vertices. Implements iPen.

virtual void csPen::PopTransform | ( |  | ) | `[virtual]`

| Pops the transform stack. The top of the stack becomes the current transform. Implements iPen.

virtual void csPen::PushTransform | ( |  | ) | `[virtual]`

| Pushes the current transform onto the stack. * Implements iPen.

virtual void csPen::Rotate | ( | const float & | a | ) | `[virtual]`

| Rotates by the given matrix. Implements iPen.

virtual void csPen::SetColor | ( | const csColor4 & | color | ) | `[virtual]`

| Sets the current color. Implements iPen.

virtual void csPen::SetColor | ( | float | r,
|  | float | g,
|  | float | b,
|  | float | a
| ) | `[virtual]`

| Sets the current color. Implements iPen.

virtual void csPen::SetOrigin | ( | const csVector3 & | o | ) | `[virtual]`

| Sets the origin of the coordinate system. Implements iPen.

void csPen::SetupMesh | ( |  | ) | `[protected]`

| Worker, sets up the mesh with the vertices, color, and other information.

void csPen::Start | ( |  | ) | `[protected]`

| Initializes our working objects.

virtual void csPen::SwapColors | ( |  | ) | `[virtual]`

| Swaps the current color and the alternate color. Implements iPen.

virtual void csPen::Translate | ( | const csVector3 & | t | ) | `[virtual]`

| Translates by the given vector. Implements iPen.

virtual void csPen::Write | ( | iFont * | font,
|  | uint | x1,
|  | uint | y1,
|  | char * | text
| ) | `[virtual]`

| Writes text in the given font at the given location. Implements iPen.

virtual void csPen::WriteBoxed | ( | iFont * | font,
|  | uint | x1,
|  | uint | y1,
|  | uint | x2,
|  | uint | y2,
|  | uint | h_align,
|  | uint | v_align,
|  | char * | text
| ) | `[virtual]`

| Writes text in the given font, in the given box. The alignment specified in h_align and v_align determine how it should be aligned. Implements iPen.

The documentation for this class was generated from the following file:

- cstool/pen.h